#pragma once

#include "Particle.h"
#include "Global.h"
#include <fstream>
using namespace std;

class CSwarm
{
public:
	int popsize;  // swarm size  
	
	double avg_fitness; // agerage fitness of whole swarm
	double std_error;   //standard deviation of whole swarm
	
	CParticle Best;  // the best one of swarm
	
	CParticle *pop;	 // the population
	CParticle *pop_best; //population of previous best position
	
	const static int max_popnum;

public:

	static CParticle *global_best; // global best one found by LPSO

	// the total number of swarms
	static int pop_num; 
	static CSwarm *sub_swarm;
	static int max_popsize;

public:
	CSwarm(void);
	CSwarm(const CSwarm &s);
	CSwarm(const int pop_size);
	~CSwarm(void);
	void Initial(const int pop_size);
	void Reinital();
	const int Find_Best(void)const;

	void Move(double best, int&, double &);
	
public:
	void Statistic(void);
public:
	void Calculate_Avgfit(void);
	void Update_Best_Pbest();
	static void Add_Pop(CSwarm &w);
	static void Delete_Pop(int index);
	void Add_Particle(CParticle &add);
	void Delete_Particle(int del);
	CSwarm &operator= (const CSwarm &s);
};
